# -*- coding: utf-8 -*-
#!/usr/bin/env python

import sys
import datetime
#from VoiceToText_docomo import VoiceToText_docomo # ★コメントアウトする
from VoiceToText_Google import VoiceToText # ★コメントアウトを外す(関数名をVoiceToTextに変更)
from Reply_DialogF import getReplyFromDialogF
from GetNews import GetNews
from GetWeather import GetWeather
from Translate_Google import Translate
from TextToSpeech_Jtalk import TextToSpeech_Jtalk
from TextToSpeech_eSpeak import TextToSpeech_eSpeak
from QA_docomo import QA_docomo
from GConversation_docomo import GConversation_docomo
#from Translate_GoogleviaN import Translate
from AnalysisImageToSpeech_Google import AnalysisImageToSpeech
from motor_drv import actionmove
from servo import ArmShake
from TalkToRecord_Google import TalkRecord

class BrainAction:
    #コンストラクタ(初期処理)
    def __init__(self):

        #処理ステータスの初期化
        self.flg_action='ini'
        
    #デストラクタ(終了処理)
    def __del__(self):
        print('end')

    #プロパティ
    #googleKey
    def google_key(self):
        return self.google_key
    
    def google_key(self,value):     
        self.google_key=value

    #中継サーバーurl
    def google_url(self):
        return self.google_url
    
    def google_url(self,value):        
        self.google_url=value

    #docomoKey
    def docomo_key(self):
        return self.docomo_key
    
    def docomo_key(self,value):        
        self.docomo_key=value

    #docomoappId
    def docomo_Id(self):
        return self.docomo_Id

    def docomo_Id(self,value):
        self.docomo_Id=value

    #Cliantaccesstoken
    def dialogF_token(self):
        return self.dialogF_token

    def dialogF_token(self,value):
        self.dialogF_token=value
        
    #flg/処理ステータス
    def flg_action(self):
        return self.flg_action
    
    def flg_action(self,value):
        self.flg_action=value    


    #失敗ケースの対応
    def act_err(self):

        #わからない発声
        txtAI='わかりません。もう一度お願いします。'
        TextToSpeech_Jtalk(txtAI.encode('utf-8'),'resVoice.wav')
        
        #---追加
        TalkRecord(txtVoice,txtAI,self.flg_action,self.google_key)

        #フラグ初期化
        self.flg_action='ini'
        
    #docomo APIで返答後にflgを初期化する
    def docomo_res(self):
        #フラグの初期化
        self.flg_action='ini'

    #アクション
    #最初のアクションで処理分岐しステータスを返す        
    def Action_1st(self,voice1,o_file): # ★引数を追加
        
        #②文字データ化
        txtVoice=VoiceToText(voice1,o_file,self.google_key) # ★Googleに変更、引数を変更

        # ★追加
        if txtVoice: # 文字化できなかった場合エラー処理をする
            self.act_err()
            return
            
        #文字化したデータが空白となった場合、処理をスキップ
        if txtVoice=='' or  txtVoice ==u'。' or  txtVoice ==u'、':
            self.act_err()
            return

        print(txtVoice)

        #返答をリクエスト
        txtReply=getReplyFromDialogF(txtVoice,self.dialogF_token)

        print(txtReply['result'][ 'score'])
        print(txtReply)
        #マッチングスコアが低い場合は処理をスキップする。
        if txtReply['result']['score']<0.8:

            #docomo 雑談APIから返答の取得
            DocomoText=GConversation_docomo(txtVoice,self.docomo_key,self.docomo_Id)
            #発声
            TextToSpeech_Jtalk(DocomoText.encode('utf-8'),'resVoice.wav')
            #---追加
            TalkRecord(txtVoice,DocomoText,'ini',self.google_key)
            
            #処理を抜ける
            self.docomo_res()

            return
        
        #DialogFlowにて制御されたactionを取得
        self.flg_action=txtReply["result"]["action"]
        print(self.flg_action)
        print(txtReply["result"]["action"])

        #DialogFlowにて返答フレーズ取得
        txtRes=txtReply["result"]["fulfillment"]["speech"]

        #取得フレーズが空白の場合は処理をスキップ
        if txtRes=='':
            self.act_err()
            return
        
        #DialogFlowにて返答フレーズの発声
        TextToSpeech_Jtalk(txtRes.encode('utf-8'),'resVoice.wav')
        print(txtRes)

        #---追加
        TalkRecord(txtVoice,txtRes,self.flg_action,self.google_key)
        
        #⑤回答による分岐(DialogFlowからのActionにより制御)
        if self.flg_action=='news':
            #⑥ニュースの読み上げ
            news=GetNews()
                                    
            #⑩発声
            for rd in news['entries']:
                tmpTxt=rd['title']
                TextToSpeech_Jtalk(tmpTxt.encode('utf-8'),'resVoice.wav')
                
                #---追加
                TalkRecord('--',tmpTxt,self.flg_action,self.google_key)
                
                print(tmpTxt)                

            #フラグ初期化
            self.flg_action='ini'    
            
        elif self.flg_action=='weather':
            #⑦天気予報
            #DialogFlowにて必要パラメータがそろっている場合に処理
            if txtReply["result"]["actionIncomplete"]==False:
                tmpArea=txtReply["result"]["parameters"]["area"]
                print(tmpArea)

                #⑩発声
                tmpWeather=GetWeather(tmpArea)
                for rd in tmpWeather['entries']:
                    TextToSpeech_Jtalk(rd['title'].encode('utf-8'),'resVoice.wav')
                    
                    #---追加
                    TalkRecord('--',rd['title'].encode('utf-8'),self.flg_action,self.google_key)
                    
                    print(rd['title'].encode('utf-8'),'resVoice.wav')
                    
            #フラグ初期化
            self.flg_action='ini'


        elif self.flg_action=='translate':
            #⑧翻訳はフラグを保持して、続きのアクションへ
            print('translate')
            
       #Q&Aの処理
        elif self.flg_action=='question':
            #QAはフラグを保持して、続きのアクションへ
            print('question')
        
        elif self.flg_action=='vision':
            #写真を保存する際のファイル名
            picture='photo.jpg'
            #Google visionからのレスポンスを翻訳するためのターゲット言語の指定
            TargetL='ja'
            AnalysisImageToSpeech(picture,0,self.google_key,TargetL)
            #フラグ初期化
            self.flg_action='ini'
            
        
        elif self.flg_action=='action_self':
            #⑪ロボットプロセスや動きに対しての制御
            tmpActSelf=txtReply["result"]["parameters"]["action_self"].encode('utf-8')
            print(tmpActSelf)
            if tmpActSelf.decode('utf-8') in {'end'}:
                #終了時
                print('****END*****')
                sys.exit()
                
            elif tmpActSelf.decode('utf-8') in {'go','left','right','back'}:
                print("足")
                #足の動き
                actionmove(tmpActSelf.decode('utf-8'))

            elif tmpActSelf.decode('utf-8') in{'raise','lower','wave'}:
                print("手")
                #手の動き
                ArmShake(tmpActSelf.decode('utf-8'))
                
                
            self.flg_action='ini'           
            
            
        else:
            #その他の場合には処理をスキップ
             print('No Action. docomo')

                    
    #flg_action/ステータスによって処理を分岐 継続/2回目アクション
    def Action_2nd(self,voice1,o_file): # ★引数を追加
        
        #②文字データ化
        txtVoice=VoiceToText(voice1,o_file,self.google_key) # ★Googleに変更

        # ★追加
        if txtVoice: # 文字化できなかった場合エラー処理をする
            self.act_err()
            return            
        
        #リクエストの内容が空白の場合、処理をスキップ
        if txtVoice =='':
            self.act_err()
            return
        
        #⑤回答による分岐
        if self.flg_action=='translate':    
            #→⑧翻訳
            ph_e=Translate(txtVoice,self.google_key)#google_urlには中継サーバーのurl
     
            print(ph_e)           
            #⑩発声
            TextToSpeech_eSpeak(ph_e,1,'english')

             #---追加
            TalkRecord(txtVoice,ph_e,self.flg_action,self.google_key)              

            #flg_actionのクリア
            self.flg_action='ini'

           #Q&Aの処理
        elif self.flg_action=='question':

            #質問の返答リクエスト
            TextQ=QA_docomo(txtVoice,self.docomo_key,self.docomo_Id)

            #回答を発声する
            TextToSpeech_Jtalk(TextQ.encode('utf-8'),'resVoice.wav')

             #---追加
            TalkRecord(txtVoice,TextQ,self.flg_action,self.google_key)           

            #フラグ初期化
        self.flg_action='ini'
  


            
            
